Attribute VB_Name = "LViewPROP"
Option Explicit

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Const BIF_RETURNONLYFSDIRS = &H1

Private Const SHGFI_DISPLAYNAME = &H200
Private Const SHGFI_EXETYPE = &H2000
Private Const SHGFI_SYSICONINDEX = &H4000  'system icon index
Private Const SHGFI_LARGEICON = &H0        'large icon
Private Const SHGFI_SMALLICON = &H1        'small icon
Private Const ILD_TRANSPARENT = &H1        'display transparent
Private Const SHGFI_SHELLICONSIZE = &H4
Private Const SHGFI_TYPENAME = &H400
Private Const BASIC_SHGFI_FLAGS = SHGFI_TYPENAME Or _
             SHGFI_SHELLICONSIZE Or SHGFI_SYSICONINDEX Or _
             SHGFI_DISPLAYNAME Or SHGFI_EXETYPE

'ListView column sizing constants
Global Const LVM_FIRST                 As Long = &H1000
Global Const LVM_SETCOLUMNWIDTH        As Long = (LVM_FIRST + 30)
Global Const LVSCW_AUTOSIZE            As Long = -1
Global Const LVSCW_AUTOSIZE_USEHEADER  As Long = -2

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const MAX_PATH = 260
Private Type SHITEMID
  CB      As Long
  abID    As Byte
End Type

Private Type ITEMIDLIST
  mkid    As SHITEMID
End Type

Private Type BrowseInfo
  hOwner          As Long
  pIDLRoot        As Long
  pszDisplayName  As String
  lpszTitle       As String
  ulFlags         As Long
  lpfn            As Long
  lParam          As Long
  iImage          As Long
End Type

Private Type SHFILEINFO
   hIcon          As Long
   iIcon          As Long
   dwAttributes   As Long
   szDisplayName  As String * MAX_PATH
   szTypeName     As String * 80
End Type

Private shinfo As SHFILEINFO

Private Type FILETIME
  dwLowDateTime     As Long
  dwHighDateTime    As Long
End Type

Private Type SYSTEMTIME
  wYear             As Integer
  wMonth            As Integer
  wDayOfWeek        As Integer
  wDay              As Integer
  wHour             As Integer
  wMinute           As Integer
  wSecond           As Integer
  wMilliseconds     As Long
End Type

Private Type WIN32_FIND_DATA
  dwFileAttributes  As Long
  ftCreationTime    As FILETIME
  ftLastAccessTime  As FILETIME
  ftLastWriteTime   As FILETIME
  nFileSizeHigh     As Long
  nFileSizeLow      As Long
  dwReserved0       As Long
  dwReserved1       As Long
  cFileName         As String * MAX_PATH
  cAlternate        As String * 14
End Type

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BrowseInfo) As Long
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function UpdateWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl&, ByVal i&, ByVal hDCDest&, ByVal x&, ByVal y&, ByVal flags&) As Long
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbSizeFileInfo As Long, ByVal uFlags As Long) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SendMessageAny Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, lParam As Any) As Long

'private Const LVM_FIRST = &H1000
Private Const LVM_SETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 54
Private Const LVM_GETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 55

Private Const LVS_EX_FULLROWSELECT = &H20
Private Const LVS_EX_GRIDLINES = &H1
Private Const LVS_EX_CHECKBOXES As Long = &H4
Private Const LVS_EX_HEADERDRAGDROP = &H10
Private Const LVS_EX_TRACKSELECT = &H8
Private Const LVS_EX_ONECLICKACTIVATE = &H40
Private Const LVS_EX_TWOCLICKACTIVATE = &H80
Private Const LVS_EX_SUBITEMIMAGES = &H2

Private Const LVIF_STATE = &H8
 
Global Const LVM_SETITEMSTATE = (LVM_FIRST + 43)
Global Const LVM_GETITEMSTATE As Long = (LVM_FIRST + 44)
Global Const LVM_GETITEMTEXT As Long = (LVM_FIRST + 45)

Global Const LVIS_STATEIMAGEMASK As Long = &HF000

Private Type LVITEM
   mask         As Long
   iItem        As Long
   iSubItem     As Long
   State        As Long
   stateMask    As Long
   pszText      As String
   cchTextMax   As Long
   iImage       As Long
   lParam       As Long
   iIndent      As Long
End Type

Private Const LVM_GETCOLUMN = (LVM_FIRST + 25)
Private Const LVM_GETCOLUMNORDERARRAY = (LVM_FIRST + 59)
Private Const LVCF_TEXT = &H4

Private Type LVCOLUMN
    mask As Long
    fmt As Long
    CX As Long
    pszText  As String
    cchTextMax As Long
    iSubItem As Long
    iImage As Long
    iOrder As Long
End Type

'hHeaderFont is the handle to the font used to draw the
'header text, and must not be destroyed unless no longer
'needed (see the Unload event).
Private hHeaderFont As Long
   
'vars representing the checkbox options in
'the chkHeaderFont control array.
Private Const optBold = 0
Private Const optItalic = 1
Private Const optUnderlined = 2
Private Const optStrikeout = 3
   
'-----------------------------------------------
'APIs, constants and structures required to change the listview header font
Private Const LVM_GETHEADER = (LVM_FIRST + 31)
      
'font weight vars
Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700
   
'SendMessage vars
Private Const WM_SETFONT = &H30
Private Const WM_GETFONT = &H31

Private Const LF_FACESIZE = 32

Private Type LOGFONT
   lfHeight As Long
   lfWidth As Long
   lfEscapement As Long
   lfOrientation As Long
   lfWeight As Long
   lfItalic As Byte
   lfUnderline As Byte
   lfStrikeOut As Byte
   lfCharSet As Byte
   lfOutPrecision As Byte
   lfClipPrecision As Byte
   lfQuality As Byte
   lfPitchAndFamily As Byte
   lfFaceName(LF_FACESIZE) As Byte
End Type

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long

' Flat Column Headers
Private Const HDS_BUTTONS = &H2
Private Const GWL_STYLE = (-16)
Const SWP_DRAWFRAME = &H20
Const SWP_NOMOVE = &H2
Const SWP_NOSIZE = &H1
Const SWP_NOZORDER = &H4
Private Const SWP_FLAGS = SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME
  
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal CX As Long, ByVal CY As Long, ByVal wFlags As Long) As Long

Private Const SW_NORMAL = 1
Private Const SW_SHOWMAXIMIZED = 3
Private Const SW_SHOWDEFAULT = 10
Private Const SW_SHOWNOACTIVATE = 4
Private Const SW_SHOWNORMAL = 1

Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Global lvwAutoREDIM As Boolean
Sub lvwSetCHECK(locLVW As ListView, locINDEX As Long, locSTATE As Boolean)

    Dim LV As LVITEM
    Dim r As Long
    Dim kk As Long
    
    kk = locINDEX - 1
    'kk = locINDEX
    
    With LV
      .mask = LVIF_STATE
      .State = IIf(locSTATE, &H2000, &H1000)
      .stateMask = LVIS_STATEIMAGEMASK
    End With
    
    r = SendMessageAny(locLVW.hWnd, LVM_SETITEMSTATE, kk, LV)

End Sub


Sub lvwCheckALL(locLVW As ListView, locSTATE As Boolean)

   Dim LV As LVITEM
   Dim lvCount As Long
   Dim lvIndex As Long
   Dim lvState As Long
   Dim r As Long
   
   
  'because IIf is much less efficient than a
  'traditional If..Then..Else statement, just call
  'once to save the state mask to a local variable
   lvState = IIf(locSTATE, &H2000, &H1000)
   
  'listview has 0 to count -1 items
   lvCount = locLVW.ListItems.Count - 1
   
   Do
         
      With LV
         .mask = LVIF_STATE
         .State = lvState
         .stateMask = LVIS_STATEIMAGEMASK
      End With
      
      r = SendMessageAny(locLVW.hWnd, LVM_SETITEMSTATE, lvIndex, LV)
      lvIndex = lvIndex + 1
   
   Loop Until lvIndex > lvCount
  
  'One could alternatively use "Loop Until r = False"
  'as r is false when the call fails (no more to set).
  
End Sub


Function lvwIsCHECKED(locLVW As ListView, locPNT As Long) As Boolean

    Dim r As Long
    Dim i As Long
    
    i = locPNT - 1

    r = SendMessageAny(locLVW.hWnd, LVM_GETITEMSTATE, i, LVIS_STATEIMAGEMASK)
    If r And &H2000& Then
        lvwIsCHECKED = True
    Else
        lvwIsCHECKED = False
    End If

End Function


Sub lvwCheckINVERT(locLVW As ListView)

   Dim LV As LVITEM
   Dim r As Long
   Dim lvCount As Long
   Dim lvIndex As Long
   
   lvCount = locLVW.ListItems.Count - 1
   
   Do
         
      r = SendMessageLong(locLVW.hWnd, LVM_GETITEMSTATE, lvIndex, LVIS_STATEIMAGEMASK)
      
      With LV
         .mask = LVIF_STATE
         .stateMask = LVIS_STATEIMAGEMASK
      
         If r And &H2000& Then
              'its checked, so set the state
              'to 'unchecked'
               .State = &H1000
         Else: .State = &H2000
         End If
         
      End With
      
      r = SendMessageAny(locLVW.hWnd, LVM_SETITEMSTATE, lvIndex, LV)
      lvIndex = lvIndex + 1
   
   Loop Until lvIndex > lvCount
   
End Sub

Sub lvwSetPROPERTIES(AB As Form, AA As ListView, HD As Boolean, FL As Boolean, GL As Boolean, CB As Boolean, FB As Boolean)

    ' setproperties main, lvw , head3D, fullLine, gridLines, check, headBold
    ' setproperties main, lvw , True, True, True, False, False

    Dim r As Long
    Dim rStyle As Long
    Dim hHeader As Long
    Dim myF As LOGFONT
    Dim hCurrFont As Long
    Dim hOldFont As Long
    
    r = -1
    rStyle = -1
    hHeader = -1
    hHeaderFont = -1
    hCurrFont = -1
    hOldFont = -1
   
    'header font bold
    If FB <> AA.Font.Bold Then
        hHeader = SendMessageLong(AA.hWnd, LVM_GETHEADER, 0, 0)
        hCurrFont = SendMessageLong(hHeader, WM_GETFONT, 0, 0)
        r = GetObject(hCurrFont, Len(myF), myF)
        If r > 0 Then
            If FB = True Then myF.lfWeight = FW_BOLD Else myF.lfWeight = FW_NORMAL
            myF.lfItalic = False
            myF.lfUnderline = False
            myF.lfStrikeOut = False
            r = DeleteObject(hHeaderFont)
            hHeaderFont = CreateFontIndirect(myF)
            hOldFont = SelectObject(hHeader, hHeaderFont)
            r = SendMessageLong(hHeader, WM_SETFONT, hHeaderFont, True)
        End If
    End If
   
    '3d Columns Header
    If HD <> True Then
        hHeader = SendMessageLong(AA.hWnd, LVM_GETHEADER, 0, ByVal 0&)
        rStyle = GetWindowLong(hHeader, GWL_STYLE)
        rStyle = rStyle Xor HDS_BUTTONS
        r = SetWindowLong(hHeader, GWL_STYLE, rStyle)
        r = SetWindowPos(AA.hWnd, AB.hWnd, 0, 0, 0, 0, SWP_FLAGS)
    End If

    'full row select
    If FL <> False Then
        rStyle = SendMessageLong(AA.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
        rStyle = rStyle Xor LVS_EX_FULLROWSELECT
        r = SendMessageLong(AA.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, rStyle)
    End If

    'show gridlines
    If GL <> False Then
        rStyle = SendMessageLong(AA.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
        rStyle = rStyle Xor LVS_EX_GRIDLINES
        r = SendMessageLong(AA.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, rStyle)
    End If

    'check boxes
    If CB <> False Then
        rStyle = SendMessageLong(AA.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
        rStyle = rStyle Xor LVS_EX_CHECKBOXES
        r = SendMessageLong(AA.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, rStyle)
    End If

End Sub



Sub lvwAutoSIZE(LV As ListView, Optional lvRIOR As Integer = -1)

    If lvRIOR <> -1 Then
        'riordina
    Else
        If lvwAutoREDIM = False Then Exit Sub
    End If

    Dim i As Long
  
    For i = 0 To LV.ColumnHeaders.Count - 1
        If LV.ColumnHeaders(i + 1).Width = 0 Then
            ' do nothing
        Else
            Call SendMessage(LV.hWnd, LVM_SETCOLUMNWIDTH, i, ByVal LVSCW_AUTOSIZE_USEHEADER)
            'Call SendMessage(LV.hWnd, LVM_SETCOLUMNWIDTH, i, ByVal LVSCW_AUTOSIZE)
        End If
    Next i
    
End Sub


