Attribute VB_Name = "sbarPANELS"
Option Explicit

Global Const sbLEFT = 0
Global Const sbRIGHT = 1
Global Const sbMIDDLE = 2
Global Const sbSPAWN = 3

'*******************************************************************************
'API
'*******************************************************************************

'SetParent
Private Declare Function SetParent Lib "user32" _
                        (ByVal hWndChild As Long, _
                         ByVal hWndNewParent As Long) As Long
'SendMessage
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                        (ByVal hWnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         lParam As Any) As Long
                         
'Type RECT
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'Const
Private Const WM_USER As Long = &H400
Private Const SB_GETRECT As Long = (WM_USER + 10)




Sub sbarMettiNelPANNELLO(sbFORM As Form, sbNAME As StatusBar, sbPNT As Long, sbOBJECT As Object, Optional sbALIGN As Integer = sbSPAWN, Optional stileXP As Boolean = False)

    Dim rectPANEL As RECT

    'Read panel coordinates and dimensions (pixel scale)
    '1 means the second panel of status bar (0-index based)
    
    SendMessage sbNAME.hWnd, SB_GETRECT, sbPNT - 1, rectPANEL
    
    'Transform coordinates from pixel to twip
    'Bottom contains the height, Right contains the width
    
    rectPANEL.Top = (rectPANEL.Top * Screen.TwipsPerPixelY)
    rectPANEL.Left = (rectPANEL.Left * Screen.TwipsPerPixelX)
    rectPANEL.Bottom = (rectPANEL.Bottom * Screen.TwipsPerPixelY) - rectPANEL.Top
    rectPANEL.Right = (rectPANEL.Right * Screen.TwipsPerPixelX) - rectPANEL.Left
    
    If rectPANEL.Bottom <= 0 Or rectPANEL.Right <= 0 Then Exit Sub
    
    'Move progress bar inside the statusbar panel
    SetParent sbOBJECT.hWnd, sbNAME.hWnd
    
    If sbALIGN = sbLEFT Then
        sbOBJECT.Move rectPANEL.Left, _
                      rectPANEL.Top + ((rectPANEL.Bottom / 2) - (sbOBJECT.Height / 2))
    ElseIf sbALIGN = sbRIGHT Then
        sbOBJECT.Move rectPANEL.Right - (sbOBJECT.Width + 16), _
                      rectPANEL.Top + ((rectPANEL.Bottom / 2) - (sbOBJECT.Height / 2))
    ElseIf sbALIGN = sbMIDDLE Then
        sbOBJECT.Move rectPANEL.Left + ((rectPANEL.Right / 2) - (sbOBJECT.Width / 2)), _
                      rectPANEL.Top + ((rectPANEL.Bottom / 2) - (sbOBJECT.Height / 2))
    ElseIf sbALIGN = sbSPAWN Then
        sbOBJECT.Move rectPANEL.Left, _
                      rectPANEL.Top, _
                      rectPANEL.Right, _
                      rectPANEL.Bottom
    End If
    
End Sub


Sub sbarCentraNelPANNELLO(sbFORM As Form, sbNAME As StatusBar, sbPNT As Long, sbOBJECT As Object, Optional stileXP As Boolean = False, Optional sbDOVE As Integer = 2)

    'sbDOVE: 0 left
    '        1 right
    '        2 center
    '

    Dim rectPANEL As RECT

    'Read panel coordinates and dimensions (pixel scale)
    '1 means the second panel of status bar (0-index based)
    
    SendMessage sbNAME.hWnd, SB_GETRECT, sbPNT - 1, rectPANEL
    
    'Transform coordinates from pixel to twip
    'Bottom contains the height, Right contains the width
    
    rectPANEL.Left = (rectPANEL.Left * Screen.TwipsPerPixelX)
    rectPANEL.Top = (rectPANEL.Top * Screen.TwipsPerPixelY)
    rectPANEL.Right = (rectPANEL.Right * Screen.TwipsPerPixelX) - rectPANEL.Left
    rectPANEL.Bottom = (rectPANEL.Bottom * Screen.TwipsPerPixelY) - rectPANEL.Top
    
    'Move progress bar inside the statusbar panel
    SetParent sbOBJECT.hWnd, sbNAME.hWnd
    
'    sbOBJECT.Move rectPANEL.Left + ((rectPANEL.Right / 2) - (sbOBJECT.Width / 2)), _
                  rectPANEL.Top + (rectPANEL.Bottom / 2) - (sbOBJECT.Width / 2)
        
    If sbDOVE = 2 Then     'center
        sbOBJECT.Move rectPANEL.Left + ((rectPANEL.Right / 2) - (sbOBJECT.Width / 2)), _
                      rectPANEL.Top
    ElseIf sbDOVE = 1 Then 'right
        sbOBJECT.Move rectPANEL.Left + (rectPANEL.Right - sbOBJECT.Width), _
                      rectPANEL.Top
    Else                   'left
        sbOBJECT.Move rectPANEL.Left, _
                      rectPANEL.Top
    End If
    
End Sub



Function sbarPanelHEIGHT(sbNAME As StatusBar) As Single

    Dim rectPANEL As RECT
    SendMessage sbNAME.hWnd, SB_GETRECT, 0, rectPANEL

    rectPANEL.Top = (rectPANEL.Top * Screen.TwipsPerPixelY)
    rectPANEL.Left = (rectPANEL.Left * Screen.TwipsPerPixelX)
    rectPANEL.Bottom = (rectPANEL.Bottom * Screen.TwipsPerPixelY) - rectPANEL.Top
    rectPANEL.Right = (rectPANEL.Right * Screen.TwipsPerPixelX) - rectPANEL.Left
    
    sbarPanelHEIGHT = rectPANEL.Bottom

End Function


